<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import type { itemEnum } from '@/enums/enums';
import { toRef } from 'vue';

export type item = {
    label?: string,
    name?: string,
    value?: string,
    id?: string,
    boxLabel?: string
}

const props = defineProps<{
    modelValue: string,
    items: item[],
    label?: string,
    type: string,
    identifier: itemEnum,
    light?: boolean
}>();

const emits = defineEmits<{
    (e: 'update:modelValue', value: string): void
}>();

const modelValue = toRef(props,'modelValue');

const setModelValue = (value:string)=>{
    emits('update:modelValue', value);
}

</script>
<template>
    <div class="">
        <span v-if="label">{{label}}:</span>
        <div class="ml-0 flex flex-row gap-0.5 flex-wrap">
            <button v-if="type==='icons'" class="p-0 w-5 h-5 cursor-pointer" :class="[{'text-red-500': item[identifier] == modelValue}]" v-for="item in items" @click="()=>setModelValue(item[identifier]!)"><i :class="type === 'icons'?'ri-'+item[identifier]+'-line text-lg leading-5':''"></i></button>
            <Tooltip v-else v-for="item in items" :tooltip="item.label ?? item.id ?? item.name ?? item.boxLabel">
            <button class="border-solid w-5 h-5 p-0 text-center leading-5 rounded-md cursor-pointer" :class="[(item[identifier] == modelValue?'border-red-500 border':'border-gray-300 border'),(type==='shapes'?'bg-white menu-'+item.id:''), {'bg-white':type==='lines'}]" @click="()=>setModelValue(item[identifier]!)" :style="{backgroundColor: type==='colors'?item.value:''}">
                <span v-if="item.boxLabel">{{item.boxLabel}}</span>
                <span v-else-if="type ==='lines'" class="bg-white h-2 w-3 border-2 mt-2 border-t-1 border-b-0 border-r-0 border-l-0 inline-block" :class="{'border-dashed': item.name === 'dotted'}" :style="{borderColor:light?'white':'black'}"></span>
            </button>
            </Tooltip>
        </div>
    </div>
</template>